#include    <avr/io.h>

.global ws2812b_senddata


#define ws_port PORTB
#define ws_pin PB0
#define LED_DATA_SIZE R24

    ; R24 contains byte count (up to 85 LEDs)
    ; R21:R22 contains LED data block address

ws2812b_senddata:
    CLI
    PUSH    R23
    IN      R23, _SFR_IO_ADDR(SREG)
	PUSH	YL
	PUSH 	YH
	MOV	YL, R22
	MOV	YH, R21

    LD  R18, Y

	; send bit 7
SB7:
    SBI _SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	SBRS	R18, 7 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	NOP
	NOP
	NOP

	; send bit 6
	SBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles
	NOP
	NOP
	SBRS	R18, 6 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	NOP
	NOP
	NOP

	; send bit 5
	SBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles
	NOP
	NOP
	SBRS	R18, 5 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	NOP
	NOP
	NOP

	; send bit 4
	SBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles
	NOP
	NOP
	SBRS	R18, 4 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	NOP
	NOP
	NOP

	; send bit 3
	SBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles
	NOP
	NOP
	SBRS	R18, 3 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	NOP
	NOP
	NOP

	; send bit 2
	SBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles
	NOP
	NOP
	SBRS	R18, 2 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	NOP
	NOP
	NOP

	; send bit 1
	SBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles
	NOP
	NOP
	SBRS	R18, 1 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y+ ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	NOP
	NOP
	NOP
	NOP


	; send bit 0
	SBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles
	NOP
	NOP
	SBRS	R18, 0 ; 1 cycles L, 2 cycles H
	CBI	_SFR_IO_ADDR(ws_port), ws_pin ; 1 cycles L. 6 cycles tot.
	LD	R18, Y ; 2 cycles, 8 tot
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP ; 14 cycles
	CBI	_SFR_IO_ADDR(ws_port), ws_pin
	NOP
	DEC	LED_DATA_SIZE
	BREQ 	END
	RJMP 	SB7
END:

	POP	    YH
	POP 	YL
    OUT     _SFR_IO_ADDR(SREG), R23
	POP     R23
    SEI
	RET
