#include "ws2812b.h"

void led_refresh(uint8_t led_count)
{
    ws2812b_senddata(led_count*3, _led_values);
    _delay_us(50);
}

inline void set_led_color(uint8_t led, uint8_t r, uint8_t g, uint8_t b, uint8_t led_type)
{
    uint8_t begin = led*3;
    if (led_type == 0) { // GRB, e.g. WS2812B
        _led_values[begin+0] = g;
        _led_values[begin+1] = r;
        _led_values[begin+2] = b;
    } else {
        _led_values[begin+0] = r;
        _led_values[begin+1] = g;
        _led_values[begin+2] = b;
    }

}

inline uint8_t get_led_r_color(uint8_t led, uint8_t led_type)
{
    return led_type ? _led_values[led*3+1] : _led_values[led*3+0];
}

inline uint8_t get_led_g_color(uint8_t led, uint8_t led_type)
{
    return led_type? _led_values[led*3+0] : _led_values[led*3+1];
}

inline uint8_t get_led_b_color(uint8_t led, uint8_t led_type)
{
    return _led_values[led*3+2];
}

inline void led_clear_array(uint8_t led_count)
{
    uint8_t i;
    for (i=0; i<led_count*3; i++)
    {
        _led_values[i] = 0;
    }
}

void led_clear(uint8_t led_count)
{
    led_clear_array(led_count);
    led_refresh(led_count);
}
